*
      SUBROUTINE CAZ_BDSV(NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE,
     $                    NB, BWL, BWU, BW, INFILEA, INFILEB, OUTFILE)
*
*          PZDBSV, PZGBSV, PZPBSV
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, BWL, BWU, BW
      DOUBLE COMPLEX     AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, INFILEB, OUTFILE, NAME, UPLO
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, INFO, IPA, IPB, IPX, IPW,
     $                   IPPIV, IPWOR, MYCOL, MYROW, NPROCS,
     $                   NP, NQ, NQRHS, NRHS, LWORK,
     $                   IA, JA, IB, JB, MMIN, WORKSIZ
*
*  
      INTEGER            DESCA(7), DESCB(7), DESCAK(9), DESCBK(9)
*
*  
      INTEGER            ICEIL, NUMROC
      DOUBLE PRECISION   PDLAMCH
      EXTERNAL           ICEIL, NUMROC, PDLAMCH
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZLAPRNT, PZLAREAD,
     $                   PZLAWRITE,
     $                   PZDBSV, PZGBSV, PZPBSV
*
*  
*
*  
*
**      NPROCS = NPROW*NPCOL
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      NRHS = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
**           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
**       NQRHS = NUMROC( NRHS, NB, MYCOL, 0, NPCOL )
*
*     A  B
*
      DESCA(1) = 501
      DESCA(2) = CTXT
      DESCA(3) = N
      DESCA(4) = NB
* CSRC
      DESCA(5) =0
* LLD_A   = 0
      DESCA(6) = 0
      DESCA(7) = 0
*
      DESCB(1) = 502
      DESCB(2) = CTXT
      DESCB(3) = N
      DESCB(4) = NB
* RSRC
      DESCB(5) = 0
* LLD_B (?)( 1)
      DESCB(6) = NB
      DESCB(7) = 0
*
*     BK
*
      CALL DESCINIT( DESCBK, 1, N, 1, NB, 0, 0, CTXT, 1, INFO )
*
      INFO = 0
* LOCr
*      NP = DESCA(6)
* LOCc
      NQ = NB
      NQRHS = NB
*
*     AMEM
*
*    ()   B
      IPB = 1
*
*NQRHS
*     A
*
      IPA = IPB + DESCB( 6 )*NRHS
*
      IF( NAME .NE. 'PZGBSV' ) GOTO 1
*
      DESCA(6) = 2*(BWL + BWU) + 1
      NP = DESCA(6)
*
*   ,    PZGBSV
*
      LWORK = (NB + BWU)*(BWL + BWU) + 6*(BWL + BWU)*(BWL + 2*BWU) +
     $        MAX(NRHS*(NB + 2*BWL + 4*BWU), 1)
*
*                 
*   
*
      IPPIV = IPA + DESCA( 6 )*NB
      LIPIV = ICEIL( 4*(NP+NB), 8 )
      IPWOR = IPPIV + DESCB( 6 )*NRHS
*
      GO TO 3
*
    1 IF( NAME .NE. 'PZDBSV' ) GOTO 2
*
      DESCA(6) = BWL + BWU + 1
      NP = DESCA(6)
*
*   ,    PZDBSV
*
      LWORK = NB*(BWL + BWU) + 6*MAX(BWL,BWU)*MAX(BWL,BWU) +
     $        MAX( (MAX(BWL,BWU)*NRHS), MAX(BWL,BWU)*MAX(BWL,BWU) )
*
      IPWOR = IPA + DESCA( 6 )*NB
*
      GO TO 3
*
    2 IF( NAME .NE. 'PZPBSV' ) GOTO 10
*
      DESCA(6) = BW + 1
      NP = DESCA(6)
*
*   ,    PZPBSV
*
      LWORK = (NB + 2*BW)*BW + MAX((BW*NRHS), BW*BW)
*
      IPWOR = IPA + DESCA( 6 )*NB
*
      GO TO 3
***
*     AK
*
    3 CALL DESCINIT(DESCAK,DESCA(6),N,DESCA(6),NB,0,0,CTXT,
     $              DESCA(6),INFO)
*
      IPW = IPWOR + LWORK
*
*     PZLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
      NPROCS = NPROCS1
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * )'   IPB,  IPA,    IPWOR,  IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPB, IPA, IPWOR,  IPW, MMIN
         WRITE( NPR, FMT = * )'   BWL,  BWU,    BW'
         WRITE( NPR, FMT = 9994 )BWL, BWU, BW
*
         WRITE( NPR, FMT = 9991 )LWORK
         IF( NAME .NE. 'PZPBSV' ) GOTO 7
         WRITE( NPR, FMT = 9983 ) UPLO
    7    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCB'
         WRITE( NPR, FMT = 9985 )DESCB  
         WRITE( NPR, FMT = * ) '  DESCAK'
         WRITE( NPR, FMT = 9985 )DESCAK  
         WRITE( NPR, FMT = * ) '  DESCBK'
         WRITE( NPR, FMT = 9985 )DESCBK  
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
*        A  B
*
      CALL PZLAREAD(INFILEA, AMEM(IPA), DESCAK, 0, 0, AMEM(IPW))
*
      CALL PZLAREAD(INFILEB, AMEM(IPB), DESCBK, 0, 0, AMEM(IPW))
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
 9985 FORMAT( / 9I5 /)
 9983 FORMAT( / 'UPLO = ', A /)
*
      CALL PZLAPRNT( DESCA(6), N, AMEM(IPA), IA, JA, DESCAK, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PZLAPRNT( NRHS, N, AMEM(IPB), IB, JB, DESCBK, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*    A * X = B
*
      IF( NAME .EQ. 'PZGBSV' ) GOTO 11
      IF( NAME .EQ. 'PZPBSV' ) GOTO 12
      IF( NAME .NE. 'PZDBSV' ) GOTO 10
*
      CALL PZDBSV( N, BWL, BWU, NRHS, AMEM(IPA), JA, DESCA,
     $             AMEM(IPB), JB, DESCB, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   11 CALL PZGBSV(N, BWL, BWU, NRHS, AMEM(IPA), JA, DESCA, AMEM(IPPIV),
     $            AMEM(IPB), JB, DESCB, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   12 CALL PZPBSV( UPLO, N, BW, NRHS, AMEM(IPA), JA, DESCA,
     $              AMEM(IPB), JB, DESCB,
     $              AMEM(IPWOR), LWORK, INFO)
      GOTO 99
*
*   X
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
         WRITE( NPR, FMT = * ) '   X'
      END IF
*
      CALL PZLAPRNT(NRHS, N, AMEM(IPB), IB, JB, DESCBK, 0, 0, 'X', NPR,
     $              AMEM( IPW ) )
**!      CALL PZLAPRNT( 1, N, B, 1, 1, DESCBK, 0, 0, 'X', NOUT, WORK2 )
*
*     
*
      CALL PZLAWRITE( OUTFILE, NRHS, N, AMEM(IPB), 1, 1, DESCBK,
     $                0, 0, AMEM(IPW) )
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'  A X = B ,'//,
     $      '  A -   ',I2,' ',I2,',',
     $       /'        ( )',
     $       ' NB = ',I2 //)
*
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2,
     $       // '     '/)
 9996 FORMAT( / '  INFO  = ', I6 /)
*
      RETURN
      END
